#ifndef		__LIBFAAD2_H_
#define		__LIBFAAD2_H_

#include	"neaacdec.h"

#define		eLIBFAAD2_DLL				"libfaad2.dll"

// 
class	CLibFaad2
{
private:
	HINSTANCE	m_hInstLib;					// dll̃CX^Xnh

	long( NEAACDECAPI *m_lpfncNeAACDecInit)( NeAACDecHandle, unsigned char *, unsigned long, unsigned long *, unsigned char *);

	NeAACDecHandle( NEAACDECAPI *m_lpfncNeAACDecOpen)(void);

	void( NEAACDECAPI *m_lpfncNeAACDecClose)( NeAACDecHandle);

	NeAACDecConfigurationPtr( NEAACDECAPI *m_lpfncNeAACDecGetCurrentConfiguration)( NeAACDecHandle);

	unsigned char( NEAACDECAPI *m_lpfncNeAACDecSetConfiguration)( NeAACDecHandle, NeAACDecConfigurationPtr);

	void*( NEAACDECAPI *m_lpfncNeAACDecDecode)( NeAACDecHandle, NeAACDecFrameInfo*, unsigned char*, unsigned long);

	char*( NEAACDECAPI *m_lpfncNeAACDecGetErrorMessage)(unsigned char);

public:
	BOOL	m_bActive;						// CuL/


private:


public:
	// W̃RXgN^
	CLibFaad2( VOID);

	// fXgN^
	~CLibFaad2();

	// DLL̏
	BOOL	LoadLibFaad2DLL( VOID);

	// AACDEC
	long	NeAACDecInit( NeAACDecHandle hDecoder, unsigned char *buffer, unsigned long buffer_size, unsigned long *samplerate, unsigned char *channels);

	// 
	NeAACDecHandle	NeAACDecOpen( void);

	// 
	void	NeAACDecClose( NeAACDecHandle hDecoder);

	// 
	NeAACDecConfigurationPtr	NeAACDecGetCurrentConfiguration( NeAACDecHandle hDecoder);

	// 
	unsigned char	NeAACDecSetConfiguration( NeAACDecHandle hDecoder, NeAACDecConfigurationPtr config);

	//
	void*	NeAACDecDecode( NeAACDecHandle hDecoder, NeAACDecFrameInfo *hInfo, unsigned char *buffer, unsigned long buffer_size);

	// 
	char*	NeAACDecGetErrorMessage( unsigned char errcode);
};

#endif	// __LIBFAAD2_H_
