// ProgressWindow.cpp : Cve[V t@C
//

#include	"stdafx.h"
#include	<mmsystem.h>
#include	<math.h>
#include	"towave.h"
#include	"ProgressWindow.h"
#include	"Shlwapi.h"
#include	"LibFaad2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define		eDECODE_RETRY_CNT_DEF		10

/////////////////////////////////////////////////////////////////////////////
// CProgressWindow _CAO


CProgressWindow::CProgressWindow(CWnd* pParent /*=NULL*/)
	: CDialog(CProgressWindow::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProgressWindow)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	m_pToWaveParam = NULL;
	m_lpchBuffer = NULL;
	m_lpdaiDecAACInfoRoot = NULL;
}

CProgressWindow::~CProgressWindow()
{
	WaitForSingleObject( m_pExecThread->m_hThread, INFINITE);	// ϊXbh҂
	ReleaseDAI();
	delete m_lpchBuffer;
}

void CProgressWindow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressWindow)
	DDX_Control(pDX, IDC_PRGRS_TOTAL, m_pPrgrsTotal);
	DDX_Control(pDX, IDC_PRGRS_TARGET, m_pPrgrsTarget);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgressWindow, CDialog)
	//{{AFX_MSG_MAP(CProgressWindow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


VOID CProgressWindow::SetParam( CToWaveParam* pToWaveParam, CLibFaad2* pLibFaad2)
{
	m_pToWaveParam = pToWaveParam;
	m_pLibFaad2 = pLibFaad2;
}


/////////////////////////////////////////////////////////////////////////////
// CProgressWindow bZ[W nh

BOOL CProgressWindow::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ

	m_pExecThread = AfxBeginThread( fncExecThread, this);

	if( m_pToWaveParam->m_bPrgrsWinTopMost) SetWindowPos( &wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// 
void CProgressWindow::OnOK()
{
}

// 
void CProgressWindow::OnCancel()
{
}

// 
VOID	CProgressWindow::RunVLC( LPSTR lpchSrcFileName, LPSTR lpchWavFileName)
{
	DWORD					dwExitCode;
//	PROCESS_INFORMATION		piProcInfo = { 0};
	STARTUPINFO				sui = { 0};
	BOOL					bResult;

	ZeroMemory( &m_piProcInfo, sizeof( m_piProcInfo));

	GetStartupInfo( &sui);
	sui.cb          = sizeof( STARTUPINFO);
	sui.dwFlags     = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
	sui.wShowWindow = SW_SHOWNORMAL;

	TCHAR	chCommandLineStr[ 4096];
	TCHAR	chCmdScrCurrentPath[ MAX_PATH];
	sprintf( chCommandLineStr, "%s \"%s\" :sout=#transcode{acodec=s16l,ab=512,channels=2}:duplicate{dst=std{access=file,mux=wav,dst=\"%s\"}} vlc:quit", m_pToWaveParam->m_lpchVLCPath, lpchSrcFileName, lpchWavFileName);


	strcpy( chCmdScrCurrentPath, lpchSrcFileName);
	*( PathFindFileName( chCmdScrCurrentPath)) = 0x00;

	bResult = CreateProcess(
		NULL,
		chCommandLineStr,
		NULL,
		NULL,
		FALSE,
		CREATE_NEW_PROCESS_GROUP | CREATE_NO_WINDOW,
		NULL,
		chCmdScrCurrentPath,
		&sui,
		&m_piProcInfo);

	m_pPrgrsTarget.SetPos( ( UINT)m_fTargetPrgrsBarMax);
	m_pPrgrsTotal.SetPos( ( UINT)m_fTotalPrgrsBarMax);

	{
		LPSTR	lpchText = new TCHAR[ strlen( lpchSrcFileName) + 256];
		sprintf( lpchText, "\"%s\"  VLC ŃfR[h", PathFindFileName( lpchSrcFileName));
		GetDlgItem( IDC_STC_PRGRS_INFO)->SetWindowText( lpchText);
		delete lpchText;
	}

	WaitForSingleObject( m_piProcInfo.hProcess, INFINITE);			// VLC̕ϊI܂ő҂
	GetExitCodeProcess( m_piProcInfo.hProcess, &dwExitCode);		// ^[R[h擾
	CloseHandle( m_piProcInfo.hProcess);
}


// libfaad2.dllAACfR[hs
BOOL	CProgressWindow::RunLibFaad2( LPSTR lpchSrcFileName, LPSTR lpchWavFileName, LPSTR lpchDelayWaveFileName, INT nDelayTime, BOOL bDirectOut)
{
	BOOL	bReturnValue = FALSE;

    NeAACDecConfigurationPtr config;
    NeAACDecHandle	hDecoder = NULL;

	INT				nDstChannels = -1;
	HANDLE			hfDstWaveFile = INVALID_HANDLE_VALUE;
	INT				nDstFileCnt = 0;
	LPSTR			lpchDstFileName = NULL;
	UINT			nFrameNo = 0;
	UINT64			nTime = 0;
	INT				nDecodeRetryCnt = eDECODE_RETRY_CNT_DEF;

	if( bDirectOut)
	{
		if( !nDelayTime) bDirectOut = FALSE;		// delay0Ȃ̂ŁAڏo̓[h
	}

	{
		LPSTR	lpchText = new TCHAR[ strlen( PathFindFileName( lpchSrcFileName)) + 256];
		sprintf( lpchText, "\"%s\"  libfaad2 ŃfR[h", PathFindFileName( lpchSrcFileName));
		GetDlgItem( IDC_STC_PRGRS_INFO)->SetWindowText( lpchText);
		delete lpchText;
	}

	// aact@Cǂݍ
	HANDLE	hfSrcFile = CreateFile(
		lpchSrcFileName,
		GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		( LPSECURITY_ATTRIBUTES)NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		( HANDLE)NULL);

	UINT	nFileSize;
	LPBYTE	lpchSrcBuffer = NULL;

	UINT	nDstBufferSize = 0;
	LPBYTE	lpchDstBuffer = NULL;

	m_nErrorNum = 0;
	m_nSampleRate = 0;

	if( hfSrcFile != INVALID_HANDLE_VALUE)
	{
		nFileSize = GetFileSize( hfSrcFile, NULL);
		lpchSrcBuffer = new BYTE[ nFileSize];

		WaveReadFile( hfSrcFile, lpchSrcBuffer, nFileSize);
		CloseHandle( hfSrcFile);

		LPBYTE	lpchAAC, lpchAACTail;
		LPBYTE	lpchAACPrev = NULL;

		lpchAAC = lpchSrcBuffer;
		lpchAACTail = lpchSrcBuffer + nFileSize;

		INT				nChannelBefore = -1;
		unsigned long	nSamplingRate;
		unsigned char	nDecodeChannelNum;
		INT				nReadSize;

		UINT			nAACDataSize = lpchAACTail - lpchAAC;
		INT				nNowPercent = 0;
		INT				nOldPercentTarget = -1;
		INT				nOldPercentTotal = -1;

		INT				nChannelNum;

		m_pPrgrsTarget.SetPos( ( UINT)m_fTargetPrgrsBarBase);
		m_pPrgrsTarget.SendMessage( PBM_SETBARCOLOR, 0, CLR_DEFAULT);

		if( m_pToWaveParam->m_bCreateLogFile)
		{
			m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoRoot = new STDECAACINFO;
			ZeroMemory( m_lpdaiDecAACInfoRoot, sizeof( STDECAACINFO));
		}

		while( lpchAAC < lpchAACTail)
		{
			// wb_̉
			if( ( ( *( USHORT*)lpchAAC) & 0xf6ff) != 0xf0ff)
			{	// wb_s
				break;
			}

			// `l
			nChannelNum = ( ( *( lpchAAC + 2) & 0x01) << 2) | ( ( *( lpchAAC + 3) & 0xc0) >> 6);

			// f[^TCY
			UINT	nDataSize = ( ( *( lpchAAC + 3) & 0x03) << 11) | ( *( lpchAAC + 4) << 3) | ( ( *( lpchAAC + 5) & 0xe0) >> 5);

			if( ( lpchAAC + nDataSize) > lpchAACTail)
			{	// I[o[Ă(ŏIt[jĂ)
				if( m_pToWaveParam->m_bCreateLogFile)
				{
					m_lpdaiDecAACInfoTail->lpNext = new STDECAACINFO;
					ZeroMemory( m_lpdaiDecAACInfoTail->lpNext, sizeof( STDECAACINFO));
					m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoTail->lpNext;

					m_lpdaiDecAACInfoTail->nTime = nTime;
					m_lpdaiDecAACInfoTail->nFrameNo = nFrameNo;
					m_lpdaiDecAACInfoTail->nAdrs = lpchAAC - lpchSrcBuffer;
					m_lpdaiDecAACInfoTail->nChannelNum = nChannelNum;
					m_lpdaiDecAACInfoTail->nStatus = eDAISTATUS_LASTFRAME_BROKEN;
				}

				bReturnValue = TRUE;	// IƌȂ
				break;
			}

			if( nChannelNum != nChannelBefore)
			{	// `lɕω
				nChannelBefore = nChannelNum;

				if( hDecoder != NULL)
				{
					m_pLibFaad2->NeAACDecClose( hDecoder);
					hDecoder = NULL;

					if( m_pToWaveParam->m_bCreateLogFile)
					{
						m_lpdaiDecAACInfoTail->lpNext = new STDECAACINFO;
						ZeroMemory( m_lpdaiDecAACInfoTail->lpNext, sizeof( STDECAACINFO));
						m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoTail->lpNext;
					}
				}
				if( m_pToWaveParam->m_bCreateLogFile)
				{
					m_lpdaiDecAACInfoTail->nTime = nTime;
					m_lpdaiDecAACInfoTail->nFrameNo = nFrameNo;
					m_lpdaiDecAACInfoTail->nAdrs = lpchAAC - lpchSrcBuffer;
					m_lpdaiDecAACInfoTail->nChannelNum = nChannelNum;
					m_lpdaiDecAACInfoTail->nStatus = eDAISTATUS_CHANGE_CHANNEL_NUM;
				}

			    hDecoder = m_pLibFaad2->NeAACDecOpen();
			    if( hDecoder == NULL) break;

				nReadSize = m_pLibFaad2->NeAACDecInit( hDecoder, lpchAAC, nDataSize, &nSamplingRate, &nDecodeChannelNum);

			    config = m_pLibFaad2->NeAACDecGetCurrentConfiguration( hDecoder);
				config->downMatrix = 1;
//				config->useOldADTSFormat = 0;
//				config->dontUpSampleImplicitSBR = 0;
				config->outputFormat = FAAD_FMT_16BIT;
    			m_pLibFaad2->NeAACDecSetConfiguration( hDecoder, config);
			}

		    NeAACDecFrameInfo	frameInfo;
		    ZeroMemory( &frameInfo, sizeof( frameInfo));
			LPWORD	lpwDecode = ( LPWORD)m_pLibFaad2->NeAACDecDecode( hDecoder, &frameInfo, lpchAAC, nDataSize);

			if( frameInfo.error > 0 || frameInfo.bytesconsumed == 0)
			{	// fR[hG[
				m_pPrgrsTarget.SendMessage( PBM_SETBARCOLOR, 0, ( LPARAM)RGB( 255, 0, 0));
				m_pPrgrsTotal.SendMessage( PBM_SETBARCOLOR, 0, ( LPARAM)RGB( 255, 0, 0));

				m_nErrorNum++;

				if( m_pToWaveParam->m_bCreateLogFile)
				{
					m_lpdaiDecAACInfoTail->lpNext = new STDECAACINFO;
					ZeroMemory( m_lpdaiDecAACInfoTail->lpNext, sizeof( STDECAACINFO));
					m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoTail->lpNext;

					m_lpdaiDecAACInfoTail->nTime = nTime;
					m_lpdaiDecAACInfoTail->nFrameNo = nFrameNo;
					m_lpdaiDecAACInfoTail->nAdrs = lpchAAC - lpchSrcBuffer;
					m_lpdaiDecAACInfoTail->nChannelNum = nChannelNum;
					m_lpdaiDecAACInfoTail->nStatus = ( DAISTATUS)frameInfo.error;
				}

				lpchAAC += nDataSize;
				nFrameNo++;
				if( ( ( *( USHORT*)lpchAAC) & 0xf6ff) == 0xf0ff)
				{	// ̃t[Ɉڍs
					if( m_pToWaveParam->m_bCreateLogFile)
					{
						m_lpdaiDecAACInfoTail->lpNext = new STDECAACINFO;
						ZeroMemory( m_lpdaiDecAACInfoTail->lpNext, sizeof( STDECAACINFO));
						m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoTail->lpNext;

						m_lpdaiDecAACInfoTail->nTime = nTime;
						m_lpdaiDecAACInfoTail->nFrameNo = nFrameNo;
						m_lpdaiDecAACInfoTail->nAdrs = lpchAAC - lpchSrcBuffer;
						m_lpdaiDecAACInfoTail->nChannelNum = nChannelNum;
						m_lpdaiDecAACInfoTail->nStatus = eDAISTATUS_FRAME_NEXT;
					}
				}
				else
				{	// t[̐擪łȂ̂ŁA擪
					while( lpchAAC < lpchAACTail)
					{
						if( ( ( *( USHORT*)lpchAAC) & 0xf6ff) == 0xf0ff) break;
						lpchAAC++;
					}

					if( m_pToWaveParam->m_bCreateLogFile)
					{
						m_lpdaiDecAACInfoTail->lpNext = new STDECAACINFO;
						ZeroMemory( m_lpdaiDecAACInfoTail->lpNext, sizeof( STDECAACINFO));
						m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoTail->lpNext;

						m_lpdaiDecAACInfoTail->nTime = nTime;
						m_lpdaiDecAACInfoTail->nFrameNo = nFrameNo;
						m_lpdaiDecAACInfoTail->nAdrs = lpchAAC - lpchSrcBuffer;
						m_lpdaiDecAACInfoTail->nChannelNum = nChannelNum;
						m_lpdaiDecAACInfoTail->nStatus = eDAISTATUS_FRAME_SKIP;
					}
				}
			}
			else
			{	// fR[h
				if( frameInfo.channels != nDstChannels)
				{	// t@CVKɍ쐬
					if( hfDstWaveFile != INVALID_HANDLE_VALUE)
					{	// 
						FinalizedWaveFile( hfDstWaveFile);
						CloseHandle( hfDstWaveFile);
						hfDstWaveFile = INVALID_HANDLE_VALUE;
					}

					if( lpchDstFileName != NULL) delete lpchDstFileName;
					lpchDstFileName = NULL;

					if( nDstFileCnt != 0)
					{
						lpchDstFileName = new TCHAR[ strlen( lpchWavFileName) + 16 + 1];
						strcpy( lpchDstFileName, lpchWavFileName);
						sprintf( PathFindExtension( lpchDstFileName), " T%d%s", nDstFileCnt, PathFindExtension( lpchWavFileName));
					}
					else
					{
						lpchDstFileName = new TCHAR[ strlen( lpchWavFileName) + 1];
						strcpy( lpchDstFileName, lpchWavFileName);
					}
					nDstFileCnt++;

					{
						hfDstWaveFile = CreateFile( 
											lpchDstFileName,
											GENERIC_WRITE,
											FILE_SHARE_READ | FILE_SHARE_WRITE,
											( LPSECURITY_ATTRIBUTES)NULL,
											CREATE_ALWAYS,
											FILE_ATTRIBUTE_NORMAL,
											( HANDLE)NULL);

						// wb_쐬
						ZeroMemory( &m_whRiffHeader, sizeof( m_whRiffHeader));
						m_whRiffHeader.dwRiffHeader = mmioFOURCC( 'R', 'I', 'F', 'F');
						m_whRiffHeader.dwWaveHeader = mmioFOURCC( 'W', 'A', 'V', 'E');

						ZeroMemory( &m_fcFmtChunk, sizeof( m_fcFmtChunk));
						m_fcFmtChunk.dwChunkName = mmioFOURCC( 'f', 'm', 't', ' ');
						m_fcFmtChunk.dwChunkSize = 16;
						m_fcFmtChunk.nFormatID = 1;
						m_fcFmtChunk.nChannelNum = frameInfo.channels;
						m_fcFmtChunk.dwSamplingRate = frameInfo.samplerate;
						m_fcFmtChunk.dwDataSpeed = frameInfo.channels * frameInfo.samplerate * 2;
						m_fcFmtChunk.nBlockSize = 2 * frameInfo.channels;
						m_fcFmtChunk.nBits = 16;

						ZeroMemory( &m_chDataChunk, sizeof( m_chDataChunk));
						m_chDataChunk.dwChunkName = mmioFOURCC( 'd', 'a', 't', 'a');

						WaveWriteFile( hfDstWaveFile, ( LPBYTE)&m_whRiffHeader, sizeof( m_whRiffHeader));
						WaveWriteFile( hfDstWaveFile, ( LPBYTE)&m_fcFmtChunk, sizeof( m_fcFmtChunk));
						WaveWriteFile( hfDstWaveFile, ( LPBYTE)&m_chDataChunk, sizeof( m_chDataChunk));
					}
					nDstChannels = frameInfo.channels;
				}
				if( frameInfo.samples)
				{
					LPBYTE	lpchWaveData;

					if( !m_nSampleRate)
					{	// TvOg
						m_nSampleRate = frameInfo.samplerate;
					}

					if( ( frameInfo.samples * frameInfo.channels) > nDstBufferSize)
					{
						delete lpchDstBuffer;

						nDstBufferSize = ( frameInfo.samples * frameInfo.channels);
						lpchDstBuffer = new BYTE[ nDstBufferSize];
					}

					lpchWaveData = lpchDstBuffer;
					if( nDecodeRetryCnt != eDECODE_RETRY_CNT_DEF)
					{	// gCĂꍇ̓obt@NA
						ZeroMemory( lpchWaveData, ( frameInfo.samples * frameInfo.channels));
					}
					else
					if( ( nChannelBefore == 0) && ( frameInfo.channels == 2) && ( m_pToWaveParam->m_blgBilingMode == eBILINGMODE_MAIN))
					{	// dŎ剹̂
						LPWORD	lpwDst, lpwEnd;
						lpwDst = ( LPWORD)lpchDstBuffer;
						lpwEnd = ( LPWORD)( lpchDstBuffer + ( frameInfo.samples * frameInfo.channels));
						while( lpwDst < lpwEnd)
						{
							*( lpwDst + 0) = *lpwDecode;
							*( lpwDst + 1) = *lpwDecode;
							lpwDst += 2;
							lpwDecode += 2;
						}
					}
					else
					if( ( nChannelBefore == 0) && ( frameInfo.channels == 2) && ( m_pToWaveParam->m_blgBilingMode == eBILINGMODE_SUB))
					{	// dŕ̂
						LPWORD	lpwDst, lpwEnd;
						lpwDst = ( LPWORD)lpchDstBuffer;
						lpwEnd = ( LPWORD)( lpchDstBuffer + ( frameInfo.samples * frameInfo.channels));
						while( lpwDst < lpwEnd)
						{
							*( lpwDst + 0) = *( lpwDecode + 1);
							*( lpwDst + 1) = *( lpwDecode + 1);
							lpwDst += 2;
							lpwDecode += 2;
						}
					}
					else
					{	// ̑
						lpchWaveData = ( LPBYTE)lpwDecode;
					}
					WaveWriteFile( hfDstWaveFile, lpchWaveData, ( frameInfo.samples * frameInfo.channels));
				}
				else
				if( --nDecodeRetryCnt)
				{	// gC
					continue;
				}
				nDecodeRetryCnt = eDECODE_RETRY_CNT_DEF;
				lpchAACPrev = lpchAAC;
				lpchAAC += frameInfo.bytesconsumed;
				nFrameNo++;
				nTime += frameInfo.samples / ( 16 / 8);					// 16bit
			}

			// vOXo[
			FLOAT		fPercent = ( FLOAT)( lpchAACTail - lpchAAC) / ( FLOAT)nAACDataSize;

			nNowPercent = ( UINT)( m_fTargetPrgrsBarBase + ( m_fTargetPrgrsBarMax - m_fTargetPrgrsBarBase) - ( ( ( m_fTargetPrgrsBarMax - m_fTargetPrgrsBarBase) * fPercent)));
			if( nNowPercent != nOldPercentTarget)
			{
				nOldPercentTarget = nNowPercent;
				m_pPrgrsTarget.SetPos( nNowPercent);
			}

			nNowPercent = ( UINT)( m_fTotalPrgrsBarBase + ( m_fTotalPrgrsBarMax - m_fTotalPrgrsBarBase) - ( ( ( m_fTotalPrgrsBarMax - m_fTotalPrgrsBarBase) * fPercent)));
			if( nNowPercent != nOldPercentTotal)
			{
				nOldPercentTotal = nNowPercent;
				m_pPrgrsTotal.SetPos( nNowPercent);
			}
		}

		if( lpchAAC >= lpchAACTail)
		{	// IĂ
			bReturnValue = TRUE;	// 

			if( m_pToWaveParam->m_bCreateLogFile)
			{
				m_lpdaiDecAACInfoTail->lpNext = new STDECAACINFO;
				ZeroMemory( m_lpdaiDecAACInfoTail->lpNext, sizeof( STDECAACINFO));
				m_lpdaiDecAACInfoTail = m_lpdaiDecAACInfoTail->lpNext;

				m_lpdaiDecAACInfoTail->nTime = nTime;
				m_lpdaiDecAACInfoTail->nFrameNo = nFrameNo;
				m_lpdaiDecAACInfoTail->nAdrs = lpchAAC - lpchSrcBuffer;
				m_lpdaiDecAACInfoTail->nChannelNum = nChannelNum;
				m_lpdaiDecAACInfoTail->nStatus = eDAISTATUS_COMPLETE;
			}
		}
		m_pPrgrsTarget.SetPos( ( UINT)m_fTargetPrgrsBarMax);
		m_pPrgrsTotal.SetPos( ( UINT)m_fTotalPrgrsBarMax);
	}

	// n
	if( hfDstWaveFile != INVALID_HANDLE_VALUE)
	{	// 
		FinalizedWaveFile( hfDstWaveFile);
		CloseHandle( hfDstWaveFile);
		hfDstWaveFile = INVALID_HANDLE_VALUE;
	}

	if( hDecoder != NULL) m_pLibFaad2->NeAACDecClose( hDecoder);
	delete lpchSrcBuffer;
	delete lpchDstBuffer;
	delete lpchDstFileName;

	return( bReturnValue);
}


// fBClt@C擾AfBCl␳t@C𐶐
LPSTR	CProgressWindow::CreateDelayFileName( LPSTR lpchWavFileName, LPINT lpnDelayTime)
{
	LPSTR	lpchDelay, lpchDelayOrg;
	LPSTR	lpchNewWavFileName = NULL;
	LPSTR	lpchText;
	INT		nDelayTime;

	lpchNewWavFileName = new TCHAR[ strlen( lpchWavFileName) + 16];
	*lpchNewWavFileName = 0x00;

	lpchText = new TCHAR[ strlen( lpchWavFileName) + 16];

	lpchDelayOrg = new TCHAR[ strlen( lpchWavFileName) + 1];
	strcpy( lpchDelayOrg, lpchWavFileName);
	lpchDelay = PathFindFileName( lpchDelayOrg);
	_strupr( lpchDelay);	// t@C啶
	// t@C"DELAY **ms"܂܂Ă邩`FbN
	while( TRUE)
	{
		lpchDelay = strstr( lpchDelay, "DELAY ");
		if( lpchDelay == NULL) break;

		if( sscanf( lpchDelay, "DELAY %dMS%s", &nDelayTime, lpchText) == 2)
		{
			if( nDelayTime != 0)
			{	// ϊs
				strcpy( lpchNewWavFileName, lpchWavFileName);
				*( lpchNewWavFileName + ( lpchDelay - lpchDelayOrg) + sizeof( "DELAY ") - 1) = 0x00;
				strcat( lpchNewWavFileName, "0");

				lpchDelay = strstr( lpchDelay, "MS");
				strcat( lpchNewWavFileName, lpchWavFileName + ( lpchDelay - lpchDelayOrg));
				strcpy( PathFindExtension( lpchNewWavFileName), ".wav");
				break;
			}
		}
		else
		{
			lpchDelay++;
		}
	}

	if( ( lpchDelay == NULL) || ( nDelayTime == 0))
	{	// Ȃ or fBCl0
		nDelayTime = 0;

		delete lpchNewWavFileName;
		lpchNewWavFileName = NULL;
	}

	if( lpnDelayTime != NULL) *lpnDelayTime = nDelayTime;
	delete lpchDelayOrg;
	delete lpchText;

	return( lpchNewWavFileName);
}


// fBClCWAV𐶐
VOID	CProgressWindow::CreateDelayWav( LPSTR lpchWavFileName, LPSTR lpchDelayWaveFileName, INT nDelayTime)
{
	BOOL			bDstError = TRUE;
	STWaveHeader	whWaveHeader;
	STCHUNKHEADER	chdChunkHeader;
	STFMTCHUNK		fcFormatChunk;
	STCHUNKHEADER	chdDataChunkHeader;
	HANDLE			hfOrgWave = INVALID_HANDLE_VALUE;
	HANDLE			hfNewWave = INVALID_HANDLE_VALUE;;

	if( !nDelayTime) return;

	if( m_pToWaveParam->m_nReverseDelay) nDelayTime *= -1;	// 𔽓]

	if( m_lpchBuffer == NULL) m_lpchBuffer = new BYTE[ m_nBufferSize];	// obt@mۂ

	hfOrgWave = CreateFile(
		lpchWavFileName,
		GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		( LPSECURITY_ATTRIBUTES)NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		( HANDLE)NULL);

	hfNewWave = CreateFile(
		lpchDelayWaveFileName,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		( LPSECURITY_ATTRIBUTES)NULL,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		( HANDLE)NULL);

	if( ( hfOrgWave != INVALID_HANDLE_VALUE) && ( hfNewWave != INVALID_HANDLE_VALUE))
	{
		UINT	nFilePointer;
		BOOL	bDetectFmtChunk = FALSE;
		ZeroMemory( &fcFormatChunk, sizeof( fcFormatChunk));

		ULONG	nFileSizeHigh;
		ULONG	nFileSizeLow = GetFileSize( hfOrgWave, &nFileSizeHigh);
		UINT64	nFileSize = nFileSizeLow | ( nFileSizeHigh << 32);
		INT		nStepMax = ( INT)( ( nFileSize + ( m_nBufferSize - 1)) / m_nBufferSize) * 2;
		INT		nStepCnt = 0;
		INT		nNowPercent, nOldPercentTarget = -1, nOldPercentTotal = -1;

		{
			LPSTR	lpchText = new TCHAR[ strlen( PathFindFileName( lpchWavFileName)) + 256];
			sprintf( lpchText, "\"%s\"  Delayl␳", PathFindFileName( lpchWavFileName));
			GetDlgItem( IDC_STC_PRGRS_INFO)->SetWindowText( lpchText);
			delete lpchText;
		}

		while( TRUE)
		{
			// wb_ǂݍ
			ZeroMemory( &whWaveHeader, sizeof( whWaveHeader));
			WaveReadFile( hfOrgWave, ( LPBYTE)&whWaveHeader, sizeof( whWaveHeader));

			if( whWaveHeader.dwRiffHeader != mmioFOURCC( 'R', 'I', 'F', 'F'))
			{	// RIFFf[^ł͂ȂB
				break;
			}
			if( whWaveHeader.dwWaveHeader != mmioFOURCC( 'W', 'A', 'V', 'E'))
			{	// WAVEf[^ł͂ȂB
				break;
			}

			// fmt`Nǂݍ
			while( TRUE)
			{
				ZeroMemory( &chdChunkHeader, sizeof( chdChunkHeader));
				if( WaveReadFile( hfOrgWave, ( LPBYTE)&chdChunkHeader, sizeof( chdChunkHeader)) != sizeof( chdChunkHeader))
				{	// ǂݍ݃G[
					break;
				}
				if( chdChunkHeader.dwChunkName == mmioFOURCC( 'f', 'm', 't', ' '))
				{	//
					CopyMemory( &fcFormatChunk, &chdChunkHeader, sizeof( chdChunkHeader));
					if( WaveReadFile( hfOrgWave, ( LPBYTE)&fcFormatChunk.nFormatID, sizeof( fcFormatChunk) - sizeof( chdChunkHeader)) != ( sizeof( fcFormatChunk) - sizeof( chdChunkHeader)))
					{	// ǂݍ݃G[
						fcFormatChunk.dwChunkName = 0;
						break;
					}
					break;
				}
				nFilePointer = SetFilePointer( hfOrgWave, 0, NULL, FILE_CURRENT);
				SetFilePointer( hfOrgWave, nFilePointer + chdChunkHeader.dwChunkSize, NULL, FILE_BEGIN);
			}

			if( fcFormatChunk.dwChunkName != mmioFOURCC( 'f', 'm', 't', ' '))
			{	// fmt`N̓ǂݍ݂ɎsĂ
				break;
			}

			if( fcFormatChunk.nFormatID != 1)
			{	// PCMf[^ł͂Ȃ
				break;
			}

			// data`Nǂݍ
			while( TRUE)
			{
				ZeroMemory( &chdDataChunkHeader, sizeof( chdDataChunkHeader));
				if( WaveReadFile( hfOrgWave, ( LPBYTE)&chdDataChunkHeader, sizeof( chdDataChunkHeader)) != sizeof( chdDataChunkHeader))
				{	// ǂݍ݃G[
					break;
				}
				if( chdDataChunkHeader.dwChunkName == mmioFOURCC( 'd', 'a', 't', 'a')) break;
				nFilePointer = SetFilePointer( hfOrgWave, 0, NULL, FILE_CURRENT);
				SetFilePointer( hfOrgWave, nFilePointer + chdDataChunkHeader.dwChunkSize, NULL, FILE_BEGIN);
			}

			if( chdDataChunkHeader.dwChunkName != mmioFOURCC( 'd', 'a', 't', 'a'))
			{	// data`N̓ǂݍ݂ɎsĂ
				break;
			}

			// Delayf[^ʂvZ
			UINT		nDelaySize = fcFormatChunk.dwSamplingRate * abs( nDelayTime) / 1000 * fcFormatChunk.nBlockSize;

			// o̓t@CɊւ𐶐
			if( nDelayTime > 0)
			{	// 擪ɖǉ
				whWaveHeader.dwFileSize += nDelaySize;
				chdDataChunkHeader.dwChunkSize += nDelaySize;
			}
			else
			{	// 擪̃f[^Jbg
				whWaveHeader.dwFileSize -= nDelaySize;
				chdDataChunkHeader.dwChunkSize -= nDelaySize;
			}

			//-------------------------
			// t@Co͂
			if( WaveWriteFile( hfNewWave, ( LPBYTE)&whWaveHeader, sizeof( whWaveHeader)) != sizeof( whWaveHeader))
			{	// ݃G[
				break;
			}
			if( WaveWriteFile( hfNewWave, ( LPBYTE)&fcFormatChunk, sizeof( fcFormatChunk)) != sizeof( fcFormatChunk))
			{	// ݃G[
				break;
			}
			if( WaveWriteFile( hfNewWave, ( LPBYTE)&chdDataChunkHeader, sizeof( chdDataChunkHeader)) != sizeof( chdDataChunkHeader))
			{	// ݃G[
				break;
			}

			if( nDelayTime > 0)
			{	// 擪ɖǉ
				LPBYTE	lpchDummy = new BYTE[ nDelaySize];
				ZeroMemory( lpchDummy, nDelaySize);
				if( WaveWriteFile( hfNewWave, lpchDummy, nDelaySize) != nDelaySize)
				{	// G[
					delete lpchDummy;
					break;
				}
				delete lpchDummy;
			}
			else
			{	// 擪Jbg
				nFilePointer = SetFilePointer( hfOrgWave, 0, NULL, FILE_CURRENT);
				SetFilePointer( hfOrgWave, nFilePointer + nDelaySize, NULL, FILE_BEGIN);
			}

			UINT	nReadSize;
			do
			{
				// ǂݍ
				nStepCnt++;
				nNowPercent = ( UINT)( m_fTargetPrgrsBarBase + ( ( m_fTargetPrgrsBarMax - m_fTargetPrgrsBarBase) * nStepCnt / nStepMax));
				if( nNowPercent != nOldPercentTarget)
				{
					nOldPercentTarget = nNowPercent;
					m_pPrgrsTarget.SetPos( nNowPercent);
				}
				nNowPercent = ( UINT)( m_fTotalPrgrsBarBase + ( ( m_fTotalPrgrsBarMax - m_fTotalPrgrsBarBase) * nStepCnt / nStepMax));
				if( nNowPercent != nOldPercentTotal)
				{
					nOldPercentTotal = nNowPercent;
					m_pPrgrsTotal.SetPos( nNowPercent);
				}
				nReadSize = WaveReadFile( hfOrgWave, m_lpchBuffer, m_nBufferSize);

				// 
				if( nReadSize)
				{
					nStepCnt++;
					nNowPercent = ( UINT)( m_fTargetPrgrsBarBase + ( ( m_fTargetPrgrsBarMax - m_fTargetPrgrsBarBase) * nStepCnt / nStepMax));
					if( nNowPercent != nOldPercentTarget)
					{
						nOldPercentTarget = nNowPercent;
						m_pPrgrsTarget.SetPos( nNowPercent);
					}
					nNowPercent = ( UINT)( m_fTotalPrgrsBarBase + ( ( m_fTotalPrgrsBarMax - m_fTotalPrgrsBarBase) * nStepCnt / nStepMax));
					if( nNowPercent != nOldPercentTotal)
					{
						nOldPercentTotal = nNowPercent;
						m_pPrgrsTotal.SetPos( nNowPercent);
					}
					if( WaveWriteFile( hfNewWave, m_lpchBuffer, nReadSize) != nReadSize)
					{	// ݎs
						break;
					}
				}
			} while( nReadSize != 0);

			if( nReadSize != 0) break;
			bDstError = FALSE;
			break;
		}
	}

	if( hfOrgWave != INVALID_HANDLE_VALUE) CloseHandle( hfOrgWave);
	if( hfNewWave != INVALID_HANDLE_VALUE) CloseHandle( hfNewWave);

	if( !bDstError)
	{	// o͂ɐĂ
		m_pPrgrsTarget.SetPos( ( INT)m_fTargetPrgrsBarMax);
		m_pPrgrsTotal.SetPos( ( INT)m_fTotalPrgrsBarMax);

		if( m_pToWaveParam->m_bOrgWavToTrashBox)
		{
			LPSTR	lpchFileName = new TCHAR[ strlen( lpchWavFileName) + 2];
			strcpy( lpchFileName, lpchWavFileName);
			*( lpchFileName + strlen( lpchFileName) + 1) = 0x00;	// double null-terminated

			SHFILEOPSTRUCT	FileOp;
			ZeroMemory( &FileOp, sizeof( FileOp));
			FileOp.hwnd                  = NULL;
			FileOp.wFunc				= FO_DELETE;
			FileOp.pFrom				= lpchFileName;
			FileOp.pTo					= NULL;
			FileOp.fFlags                = FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_SILENT;
			FileOp.fAnyOperationsAborted = FALSE;
			FileOp.hNameMappings         = NULL;
			FileOp.lpszProgressTitle     = NULL;
			SHFileOperation( &FileOp);

			delete lpchFileName;
		}
	}
	else
	{	// o͂ɎsĂ
		DeleteFile( lpchDelayWaveFileName);
	}
}


// t@Cǂݍ
UINT	CProgressWindow::WaveReadFile( HANDLE hfHandle, LPBYTE lpchBuffer, UINT nReadSize)
{
	DWORD	dwNumberOfBytesRead;

	if( ReadFile( hfHandle, lpchBuffer, nReadSize, &dwNumberOfBytesRead, ( LPOVERLAPPED)NULL) == FALSE)
	{	// t@Cɓǂݍ߂Ȃ
		return( 0);
	}

#if 0
	if( dwNumberOfBytesRead != nReadSize)
	{	// t@Cɓǂ߂Ȃ
		return( 0);
	}
#endif

	return( dwNumberOfBytesRead);
}

// t@C
UINT	CProgressWindow::WaveWriteFile( HANDLE hfHandle, LPBYTE lpchBuffer, UINT nWriteSize)
{
	DWORD	dwNumberOfBytesWrite;

	if( WriteFile( hfHandle, lpchBuffer, nWriteSize, &dwNumberOfBytesWrite, ( LPOVERLAPPED)NULL) == FALSE)
	{
		return( 0);
	}

#if 0
	if( dwNumberOfBytesWrite != nWriteSize)
	{
		return( 0);
	}
#endif

	return( dwNumberOfBytesWrite);
}

// t@C
UINT	CProgressWindow::WaveWriteFile( HANDLE hfHandle, LPSTR lpchText)
{
	return( WaveWriteFile( hfHandle, ( LPBYTE)lpchText, strlen( lpchText)));
}

// t@CɉsR[h
UINT	CProgressWindow::WaveWriteFileCRLF( HANDLE hfHandle)
{
	return( WaveWriteFile( hfHandle, ( LPBYTE)"\x0d\x0a", strlen( "\x0d\x0a")));
}


// wavet@C̏o͊
VOID	CProgressWindow::FinalizedWaveFile( HANDLE hfHandle)
{
	LONG	nHigh = 0;
	UINT	nFileSize;
	UINT64	nFileSize64;
	nFileSize = SetFilePointer( hfHandle, 0, &nHigh, FILE_CURRENT);
	nFileSize64 = nFileSize | ( ( UINT64)nHigh << 32);

	if( nFileSize64 & ~0x7fffffff)
	{	// 2GB𒴂Ă
		m_whRiffHeader.dwFileSize = 0x7fffffff;
		m_chDataChunk.dwChunkSize = 0x7fffffff;
	}
	else
	{
		m_whRiffHeader.dwFileSize = nFileSize - 8;
		m_chDataChunk.dwChunkSize = nFileSize - ( sizeof( STWaveHeader) + sizeof( STFMTCHUNK) + sizeof( STCHUNKHEADER));
	}

	SetFilePointer( hfHandle, 0, 0, FILE_BEGIN);
	WaveWriteFile( hfHandle, ( LPBYTE)&m_whRiffHeader, sizeof( m_whRiffHeader));
	WaveWriteFile( hfHandle, ( LPBYTE)&m_fcFmtChunk, sizeof( m_fcFmtChunk));
	WaveWriteFile( hfHandle, ( LPBYTE)&m_chDataChunk, sizeof( m_chDataChunk));
}

// ڍ׃Ot@C̏o
VOID	CProgressWindow::CreateLogFile( LPSTR lpchSrcFileName, LPSTR lpchWavFileName, LPSTR lpchDelayWavFileName, INT nDelayTime)
{
	LPSTR	lpchFileName = new TCHAR[ strlen( lpchSrcFileName) + 4 + 1];
	strcpy( lpchFileName, lpchSrcFileName);
	strcpy( PathFindExtension( lpchFileName), ".log");

	HANDLE	hfLogFile = CreateFile(
		lpchFileName,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		( LPSECURITY_ATTRIBUTES)NULL,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		( HANDLE)NULL);

	TCHAR	chText[ 4096];
	TCHAR	chTemp[ 4096];
	UINT	nNativeTime;

	LPSTDECAACINFO	lpdaiTemp = m_lpdaiDecAACInfoRoot;

	if( hfLogFile != INVALID_HANDLE_VALUE)
	{
		// wb_
		WaveWriteFile( hfLogFile, "̓t@C    \"");
		WaveWriteFile( hfLogFile, lpchSrcFileName);
		WaveWriteFile( hfLogFile, "\"\x0d\x0a");

		WaveWriteFile( hfLogFile, "o̓t@C    \"");
		WaveWriteFile( hfLogFile, ( lpchDelayWavFileName != NULL)? lpchDelayWavFileName: lpchWavFileName);
		WaveWriteFile( hfLogFile, "\"\x0d\x0a");

		WaveWriteFile( hfLogFile, "Delay␳       ");
		if( m_pToWaveParam->m_bCreateDelayWav)
		{
			sprintf( chText, "%dms\x0d\x0a", nDelayTime);
			WaveWriteFile( hfLogFile, chText);
		}
		else
		{
			WaveWriteFile( hfLogFile, "\x0d\x0a");
		}

		sprintf( chText, "fR[_        %s\x0d\x0a", ( n_nDecoder == eDECODER_VLC)? "VLC": "libfaad2");
		WaveWriteFile( hfLogFile, chText);

		WaveWriteFileCRLF( hfLogFile);

		if( m_lpdaiDecAACInfoRoot != NULL)
		{
			UINT	nFrameNumLength = ( UINT)log10( m_lpdaiDecAACInfoTail->nFrameNo) + 1;

			if( nFrameNumLength < strlen( "FrameNo"))
			{
				nFrameNumLength = strlen( "FrameNo");
			}

			// t[
			sprintf( chTemp, "%%%ds          Time  Status\x0d\x0a", nFrameNumLength);
			sprintf( chText, chTemp, "FrameNo");
			WaveWriteFile( hfLogFile, chText);

			while( lpdaiTemp)
			{
				nNativeTime = ( UINT)( lpdaiTemp->nTime * 1000 / m_nSampleRate);
				sprintf( chTemp, "%%%du  %02d:%02d:%02d.%03d  ", nFrameNumLength,
					( INT)( nNativeTime / 1000 / 60 / 60),
					( INT)( nNativeTime / 1000 / 60 % 60),
					( INT)( nNativeTime / 1000 % 60),
					( INT)( nNativeTime % 1000));

				sprintf( chText, chTemp, lpdaiTemp->nFrameNo);

				if( lpdaiTemp->nStatus > 0)
				{	// libfaad2̃G[
					sprintf( chText + strlen( chText), "DecodeError(%d) \"%s\"\x0d\x0a", lpdaiTemp->nStatus, m_pLibFaad2->NeAACDecGetErrorMessage( lpdaiTemp->nStatus));
				}
				else
				{
					switch( lpdaiTemp->nStatus)
					{
					case	eDAISTATUS_CHANGE_CHANNEL_NUM:
						switch( lpdaiTemp->nChannelNum)
						{
						case	0:
							switch( m_pToWaveParam->m_blgBilingMode)
							{
							case	eBILINGMODE_BOTH:
								strcpy( chText + strlen( chText), "񃖍Ed(剹{)");
								break;
							case	eBILINGMODE_MAIN:
								strcpy( chText + strlen( chText), "񃖍Ed(剹)");
								break;
							case	eBILINGMODE_SUB:
								strcpy( chText + strlen( chText), "񃖍Ed()");
								break;
							}
							break;
						case	1:
							strcpy( chText + strlen( chText), "m");
							break;
						case	2:
							strcpy( chText + strlen( chText), "XeI");
							break;
						case	6:
							strcpy( chText + strlen( chText), "5.1ch");
							break;
						default:
							sprintf( chText + strlen( chText), "%dch", lpdaiTemp->nChannelNum);
							break;
						}
						break;
					case	eDAISTATUS_FRAME_NEXT:
						strcpy( chText + strlen( chText), "Ot[G[̂Ŏt[Ɉړ");
						break;
					case	eDAISTATUS_FRAME_SKIP:
						sprintf( chText + strlen( chText), "Ot[G[̂ŃAhX0x%xɈړ", lpdaiTemp->nAdrs);
						break;
					case	eDAISTATUS_LASTFRAME_BROKEN:
						strcpy( chText + strlen( chText), "ŏIt[̃f[^Ă̂ŃfR[h܂");
						break;
					case	eDAISTATUS_COMPLETE:
						strcpy( chText + strlen( chText), "I");
						break;
					}
					strcat( chText, "\x0d\x0a");
				}
				WaveWriteFile( hfLogFile, chText);
				lpdaiTemp = lpdaiTemp->lpNext;
			}
		}
		CloseHandle( hfLogFile);
	}

	delete lpchFileName;
}


// fR[h񃊃Xg̉
VOID	CProgressWindow::ReleaseDAI( VOID)
{
	LPSTDECAACINFO	lpdaiTemp = m_lpdaiDecAACInfoRoot;
	LPSTDECAACINFO	lpdaiNext;

	while( lpdaiTemp)
	{
		lpdaiNext = lpdaiTemp->lpNext;
		delete lpdaiTemp;
		lpdaiTemp = lpdaiNext;
	}
	m_lpdaiDecAACInfoRoot = NULL;
}


// 
UINT	CProgressWindow::fncExecThread( LPVOID pParam)
{
	( ( CProgressWindow*)pParam)->fncExecThreadMain();

	return( 0);
}

// 
VOID	CProgressWindow::fncExecThreadMain( VOID)
{
	INT		nNumArgs;
	LPWSTR*	lpwCommandLine = CommandLineToArgvW( GetCommandLineW(), &nNumArgs);

	INT		lc, lc2;
	INT		nLength;
	LPSTR	lpchArgs;
	LPSTR	lpchWavFileName;
	LPSTR	lpchDelayWavFileName;
	INT		nDelayTime;
	BOOL	bExecSuccess;
	BOOL	bDelayWavDirectOut;

	bDelayWavDirectOut = m_pToWaveParam->m_bCreateDelayWav? m_pToWaveParam->m_bDelayWavDirectOut: FALSE;

	m_nBufferSize = m_pToWaveParam->m_nBufferSizeMB * 1024 * 1024;

	for( lc=1; lc<nNumArgs; lc++)
	{
		lpchWavFileName = NULL;
		lpchDelayWavFileName = NULL;
		nDelayTime = 0;

		// R}hC擾
		nLength = WideCharToMultiByte(
			CP_ACP,
			0,
			*( lpwCommandLine + lc),
			-1,
			NULL,
			0,
			NULL,
			NULL
		);

		lpchArgs = new TCHAR[ nLength + 1];
		WideCharToMultiByte(
			CP_ACP,
			0,
			*( lpwCommandLine + lc),
			-1,
			lpchArgs,
			nLength,
			NULL,
			NULL
		);

		LPSTR	lpchExt = PathFindExtension( lpchArgs);
		if( *lpchExt == '.') lpchExt++;

		for( lc2=0; lc2<m_pToWaveParam->m_nExtNum; lc2++)
		{
			if( stricmp( lpchExt, *( m_pToWaveParam->m_lppchExtList + lc2)) == 0) break;	// 
		}

		if( lc2 != m_pToWaveParam->m_nExtNum)
		{	// ϊΏۂ̊gq
			lpchWavFileName = new TCHAR[ strlen( lpchArgs) + 16];

			strcpy( lpchWavFileName, lpchArgs);
			strcpy( PathFindExtension( lpchWavFileName), ".wav");	// o̓t@C(Delay␳O)

			if( m_pToWaveParam->m_bCreateDelayWav)
			{	// Delay␳lADelay␳̃t@C擾
				lpchDelayWavFileName = CreateDelayFileName( lpchWavFileName, &nDelayTime);
			}

			m_nErrorNum = 0;

			m_fTargetPrgrsBarBase = 0;
			m_fTargetPrgrsBarMax  = ( nDelayTime && !bDelayWavDirectOut)? 50.f: 100.f;

			m_fTotalPrgrsBarBase = ( FLOAT)( 100 * ( lc - 1) / ( nNumArgs - 1));
			m_fTotalPrgrsBarMax = ( FLOAT)( ( 100 * lc / ( nNumArgs - 1)) - ( ( m_fTargetPrgrsBarMax == 100.f)? 0: ( 100 / ( nNumArgs - 1) / 2)));

			if( ( stricmp( lpchExt, "aac") == 0) && m_pToWaveParam->m_bLoadFaad2Lib && m_pToWaveParam->m_bUseLibFaad2)
			{	// aact@Clibfaad2.dllgăfR[h
				bExecSuccess = RunLibFaad2( lpchArgs, lpchWavFileName, lpchDelayWavFileName, nDelayTime, bDelayWavDirectOut);
				n_nDecoder = eDECODER_LIBFAAD2;

			}
			else
			{	// vlcgăfR[h
				RunVLC( lpchArgs, lpchWavFileName);
				bExecSuccess = TRUE;
				n_nDecoder = eDECODER_VLC;
			}

			// Delayl␳wav𐶐
			if( nDelayTime && bExecSuccess)
			{
				m_fTargetPrgrsBarBase = 50.f;
				m_fTargetPrgrsBarMax  = 100.f;

				m_fTotalPrgrsBarBase = m_fTotalPrgrsBarMax;
				m_fTotalPrgrsBarMax = ( FLOAT)( 100 * lc / ( nNumArgs - 1));

				CreateDelayWav( lpchWavFileName, lpchDelayWavFileName, nDelayTime);
			}

			if( m_pToWaveParam->m_bCreateLogFile)
			{	// ڍ׃Ot@Co͂
				CreateLogFile( lpchArgs, lpchWavFileName, lpchDelayWavFileName, nDelayTime);
			}

			ReleaseDAI();
		}

		//
		delete lpchDelayWavFileName;
		delete lpchWavFileName;
		delete lpchArgs;
	}

	LocalFree( lpwCommandLine);

	// 
	CDialog::OnCancel();
}
