// ToWaveDlg.cpp : Cve[V t@C
//

#include	"stdafx.h"
#include	"ToWave.h"
#include	"ToWaveDlg.h"
#include	<tlhelp32.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static	const	INT		nDelayCtrlItem[] = { IDC_STC_DELAY_PARAM, IDC_CHK_ORG_WAV_DELETE, IDC_CHK_REVERSE_DELAY};
static	const	INT		nBilingualCtrlItem[] = { IDC_STC_BILING, IDC_RADIO_BILING_BOTH, IDC_RADIO_BILING_MAIN, IDC_RADIO_BILING_SUB};
static	const	INT		nBilingualMode[] = { IDC_RADIO_BILING_BOTH, IDC_RADIO_BILING_MAIN, IDC_RADIO_BILING_SUB};

#define		eFILEEXT_EXE		".exe"
#define		eEXE_FILE_FILTER	"st@C(*"##eFILEEXT_EXE")\0*"##eFILEEXT_EXE"\0SẴt@C(*.*)\0*.*\0\0"


/////////////////////////////////////////////////////////////////////////////
// CToWaveDlg _CAO

CToWaveDlg::CToWaveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CToWaveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CToWaveDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CToWaveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToWaveDlg)
	DDX_Control(pDX, IDC_EDT_EXT, m_editExt);
	DDX_Control(pDX, IDC_EDT_VLC_PATH, m_editVLCPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CToWaveDlg, CDialog)
	//{{AFX_MSG_MAP(CToWaveDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_SETFOCUS(IDC_EDT_VLC_PATH, OnSetfocusEdtVlcPath)
	ON_EN_SETFOCUS(IDC_EDT_EXT, OnSetfocusEdtExt)
	ON_BN_CLICKED(IDC_BTN_VLC_FILE, OnBtnVlcFile)
	ON_BN_CLICKED(IDC_BTN_VLC_SEARCH, OnBtnVlcSearch)
	ON_BN_CLICKED(IDC_CHK_DELAY_WAV, OnChkDelayWav)
	ON_EN_SETFOCUS(IDC_EDT_BUFFER_SIZE, OnSetfocusEdtBufferSize)
	ON_EN_KILLFOCUS(IDC_EDT_BUFFER_SIZE, OnKillfocusEdtBufferSize)
	ON_BN_CLICKED(IDC_CHK_USE_FAAD2, OnChkUseFaad2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToWaveDlg bZ[W nh

BOOL CToWaveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	m_editVLCPath.LimitText( MAX_PATH);
	m_editExt.LimitText( MAX_PATH);

	m_editVLCPath.SetWindowText( m_pToWaveParam->m_lpchVLCPath);
	m_editExt.SetWindowText( m_pToWaveParam->m_lpchExt);

	if( m_pToWaveParam->m_bUseLibFaad2) ( ( CButton*)GetDlgItem( IDC_CHK_USE_FAAD2))->SetCheck( BST_CHECKED);
	if( m_pToWaveParam->m_bCreateDelayWav) ( ( CButton*)GetDlgItem( IDC_CHK_DELAY_WAV))->SetCheck( BST_CHECKED);
	if( m_pToWaveParam->m_bOrgWavToTrashBox) ( ( CButton*)GetDlgItem( IDC_CHK_ORG_WAV_DELETE))->SetCheck( BST_CHECKED);
	if( m_pToWaveParam->m_nReverseDelay) ( ( CButton*)GetDlgItem( IDC_CHK_REVERSE_DELAY))->SetCheck( BST_CHECKED);

	( ( CButton*)GetDlgItem( IDC_CHK_USE_FAAD2))->EnableWindow( m_pToWaveParam->m_bLoadFaad2Lib);

	( ( CButton*)GetDlgItem( nBilingualMode[ m_pToWaveParam->m_blgBilingMode]))->SetCheck( BST_CHECKED);

	TCHAR	chText[ 256];
	sprintf( chText, "%d", m_pToWaveParam->m_nBufferSizeMB);
	( ( CEdit*)GetDlgItem( IDC_EDT_BUFFER_SIZE))->SetWindowText( chText);

	( ( CEdit*)GetDlgItem( IDC_EDT_BUFFER_SIZE))->LimitText( 4);

	( ( CSpinButtonCtrl*)GetDlgItem( IDC_SPIN_BUFFER_SIZE))->SetRange( eBUFFER_SIZE_MIN, eBUFFER_SIZE_MAX);

	if( m_pToWaveParam->m_bPrgrsWinTopMost) ( ( CButton*)GetDlgItem( IDC_CHK_PRGRS_TOPMOST))->SetCheck( BST_CHECKED);
	if( m_pToWaveParam->m_bCreateLogFile) ( ( CButton*)GetDlgItem( IDC_CHK_CREATE_LOGFILE))->SetCheck( BST_CHECKED);

	SetBilingualItemState();
	OnChkDelayWav();

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CToWaveDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CToWaveDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


VOID CToWaveDlg::SetParam( CToWaveParam* pToWaveParam)
{
	m_pToWaveParam = pToWaveParam;
}

void CToWaveDlg::OnSetfocusEdtVlcPath() 
{
	m_editVLCPath.PostMessage( EM_SETSEL, 0, -1);	// SI
}

void CToWaveDlg::OnSetfocusEdtExt() 
{
	m_editExt.PostMessage( EM_SETSEL, 0, -1);	// SI
}

// 
void CToWaveDlg::OnBtnVlcFile() 
{
	OPENFILENAME	ofn;
	TCHAR			chFileName[ MAX_PATH];		// t@C
	TCHAR			chFileNameExe[ MAX_PATH];		// t@C

	ZeroMemory( &ofn, sizeof( ofn));

	m_editVLCPath.GetWindowText( chFileName, sizeof( chFileName));

	strcpy( chFileNameExe, "vlc.exe");

	// t@C_CAOI[v
	ofn.lStructSize	      = sizeof( OPENFILENAME);
	ofn.hwndOwner         = m_hWnd;
	ofn.hInstance         = GetModuleHandle( 0);
	ofn.lpstrFilter       = eEXE_FILE_FILTER;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 1;
	ofn.lpstrFile         = chFileNameExe;
	ofn.nMaxFile          = sizeof( chFileNameExe);
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = chFileName;
	ofn.lpstrTitle        = "VLCw";
	ofn.Flags             = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = eFILEEXT_EXE;
	ofn.lCustData         = 0;
	ofn.lpfnHook          = NULL;
	ofn.lpTemplateName    = NULL;

	if( GetOpenFileName( &ofn))
	{	// 
		m_editVLCPath.SetWindowText( chFileNameExe);
		m_editVLCPath.PostMessage( EM_SETSEL, 0, -1);	// SI
	}
}

// EBhEnhÃW[̃tpX擾
//   lFPlatformSDKłBuild\
BOOL	CToWaveDlg::GetFileNameFromHwnd( HWND hWndTarget, LPTSTR lpszFileName, DWORD nSize)
{
	BOOL	bResult = FALSE;

	// EBhE쐬vZX ID 擾
	DWORD	dwProcessId;
	GetWindowThreadProcessId( hWndTarget , &dwProcessId);

	// PSAPI ֐̃|C^
	BOOL( WINAPI *lpfncEnumProcessModules)( HANDLE, HMODULE*, DWORD, LPDWORD);
	DWORD( WINAPI *lpfncGetModuleFileNameEx)( HANDLE, HMODULE, LPTSTR, DWORD);

	// PSAPI.DLL Cu[h
	HINSTANCE hInstLib = LoadLibrary( "PSAPI.DLL");
	if( hInstLib == NULL) return( FALSE);

	// vV[W̃AhX擾
	lpfncEnumProcessModules = ( BOOL( WINAPI *)( HANDLE, HMODULE *, DWORD, LPDWORD))GetProcAddress( hInstLib, "EnumProcessModules");
	lpfncGetModuleFileNameEx = ( DWORD( WINAPI *)( HANDLE, HMODULE, LPTSTR, DWORD))GetProcAddress( hInstLib, "GetModuleFileNameExA");

	if( lpfncEnumProcessModules && lpfncGetModuleFileNameEx)
	{	// vZXIuWFNg̃nh擾
		HANDLE	hProcess;
		hProcess = OpenProcess( PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);
		if( hProcess)
		{	// .EXE W[̃nh擾
			HMODULE	hModule;
			DWORD	dwNeed;
			if( lpfncEnumProcessModules( hProcess, &hModule, sizeof( hModule), &dwNeed))
			{	// W[nhtpX擾
				if( lpfncGetModuleFileNameEx( hProcess, hModule, lpszFileName, nSize)) bResult = TRUE;
			}
			// vZXIuWFNg̃nhN[Y
			CloseHandle( hProcess);
		}
	}
	// PSAPI.DLL CuJ
	FreeLibrary( hInstLib);
	return( bResult);
}

// 񃖍Ed֘ÃACȅԂݒ
VOID	CToWaveDlg::SetBilingualItemState( VOID)
{
	INT		nStyle = ( ( ( CButton*)GetDlgItem( IDC_CHK_USE_FAAD2))->GetCheck() == BST_CHECKED)? TRUE: FALSE;
	INT		lc;

	if( !m_pToWaveParam->m_bLoadFaad2Lib) nStyle = FALSE;

	for( lc=0; lc<sizeof( nBilingualCtrlItem) / sizeof( nBilingualCtrlItem[ 0]); lc++)
	{
		GetDlgItem( nBilingualCtrlItem[ lc])->EnableWindow( nStyle);
	}
}

// 
void CToWaveDlg::OnBtnVlcSearch() 
{
	// NVLC
	HWND	hWndVCL = ::FindWindow( "wxWindowClassNR", "VLC media player");
	BOOL	bDetect = FALSE;


	if( hWndVCL != NULL)
	{
		TCHAR	szTmpStr[ MAX_PATH];

		if( GetFileNameFromHwnd( hWndVCL, szTmpStr, MAX_PATH))
		{	// 擾ɐ
			m_editVLCPath.SetWindowText( szTmpStr);
			bDetect = TRUE;
		}
	}
	if( !bDetect)
	{
		AfxMessageBox( "VLC media playero鎖o܂łB", MB_OK | MB_ICONINFORMATION);
	}

}

void CToWaveDlg::OnChkDelayWav() 
{
	INT		nStyle = ( ( ( CButton*)GetDlgItem( IDC_CHK_DELAY_WAV))->GetCheck() == BST_CHECKED)? TRUE: FALSE;
	INT		lc;

	for( lc=0; lc<sizeof( nDelayCtrlItem) / sizeof( nDelayCtrlItem[ 0]); lc++)
	{
		GetDlgItem( nDelayCtrlItem[ lc])->EnableWindow( nStyle);
	}
}

void CToWaveDlg::OnSetfocusEdtBufferSize() 
{
	GetDlgItem( IDC_EDT_BUFFER_SIZE)->PostMessage( EM_SETSEL, 0, -1);	// SI
}

void CToWaveDlg::OnKillfocusEdtBufferSize() 
{
	TCHAR	chText[ 256];
	INT		nNum;

	( ( CEdit*)GetDlgItem( IDC_EDT_BUFFER_SIZE))->GetWindowText( chText, sizeof( chText));
	sscanf( chText, "%d", &nNum);
	if( eBUFFER_SIZE_MIN > nNum) nNum = eBUFFER_SIZE_MIN;
	if( nNum > eBUFFER_SIZE_MAX) nNum = eBUFFER_SIZE_MAX;

	sprintf( chText, "%d", nNum);
	( ( CEdit*)GetDlgItem( IDC_EDT_BUFFER_SIZE))->SetWindowText( chText);
}

void CToWaveDlg::OnOK() 
{
	INT		lc;

	m_editVLCPath.GetWindowText( m_pToWaveParam->m_lpchVLCPath, MAX_PATH);
	m_editExt.GetWindowText( m_pToWaveParam->m_lpchExt, MAX_PATH);

	m_pToWaveParam->m_bUseLibFaad2 = ( ( ( CButton*)GetDlgItem( IDC_CHK_USE_FAAD2))->GetCheck() == BST_CHECKED)? TRUE: FALSE;
	m_pToWaveParam->m_bCreateDelayWav = ( ( ( CButton*)GetDlgItem( IDC_CHK_DELAY_WAV))->GetCheck() == BST_CHECKED)? TRUE: FALSE;
	m_pToWaveParam->m_bOrgWavToTrashBox = ( ( ( CButton*)GetDlgItem( IDC_CHK_ORG_WAV_DELETE))->GetCheck() == BST_CHECKED)? TRUE: FALSE;
	m_pToWaveParam->m_nReverseDelay = ( ( ( CButton*)GetDlgItem( IDC_CHK_REVERSE_DELAY))->GetCheck() == BST_CHECKED)? TRUE: FALSE;

	TCHAR	chText[ 256];
	( ( CEdit*)GetDlgItem( IDC_EDT_BUFFER_SIZE))->GetWindowText( chText, sizeof( chText));
	sscanf( chText, "%d", &m_pToWaveParam->m_nBufferSizeMB);
	if( eBUFFER_SIZE_MIN > m_pToWaveParam->m_nBufferSizeMB) m_pToWaveParam->m_nBufferSizeMB = eBUFFER_SIZE_MIN;
	if( m_pToWaveParam->m_nBufferSizeMB > eBUFFER_SIZE_MAX) m_pToWaveParam->m_nBufferSizeMB = eBUFFER_SIZE_MAX;

	for( lc=0; lc<sizeof( nBilingualMode) / sizeof( nBilingualMode[0]); lc++)
	{
		if( ( ( CButton*)GetDlgItem( nBilingualMode[ lc]))->GetCheck() == BST_CHECKED)
		{
			m_pToWaveParam->m_blgBilingMode = ( BILINGMODE)lc;
			break;
		}
	}

	m_pToWaveParam->m_bPrgrsWinTopMost = ( ( ( CButton*)GetDlgItem( IDC_CHK_PRGRS_TOPMOST))->GetCheck() == BST_CHECKED)? TRUE: FALSE;
	m_pToWaveParam->m_bCreateLogFile = ( ( ( CButton*)GetDlgItem( IDC_CHK_CREATE_LOGFILE))->GetCheck() == BST_CHECKED)? TRUE: FALSE;

	CDialog::OnOK();
}


void CToWaveDlg::OnChkUseFaad2() 
{
	SetBilingualItemState();
}
