
#include	"StdAfx.h"
#include	"Shlwapi.h"
#include	"ToWaveParam.h"

#pragma		comment( lib, "Shlwapi.lib")

// INIt@C
#define		eINI_SECTION_NAME			"ToWave"					// ZNV

// vWFNgɊւ
#define		eINI_KEY_VLC_PATH			"VLCPath"					// VLC̃pX
#define		eINI_KEY_EXT				"Ext"						// Ήgq
#define		eINI_KEY_CREATE_DELAY_WAV	"CreateDelayWav"			// Delay𒲐WAV𐶐
#define		eINI_KEY_BILING_MODE		"BilingualMode"				// 񃖍Ed
#define		eINI_KEY_BUFFER_SIZE		"BufferSize"				// obt@TCY
#define		eINI_KEY_DELETE_ORGWAV		"OrgWavDelete"				// IWiWAVS~ɓ
#define		eINI_KEY_REVERSE_DELAY		"ReverseDelay"				// Delay̕𔽓]
#define		eINI_KEY_USE_LIBFAAD2		"UseLibfaad2"				// libfaad2.dllgp
#define		eINI_KEY_PRGRS_WIN_TOPMOST	"TopMost"					// oߕ\EChEőOʂɕ\
#define		eINI_KEY_CREATE_LOGFILE		"LogFile"					// ڍׂȃOt@Co͂

// W̃RXgN^
CToWaveParam::CToWaveParam( CToWaveParam* pToWaveParam/*=NULL*/)
{
	if( pToWaveParam != NULL)
	{	// l
		m_lpchVLCPath = new TCHAR[ strlen( pToWaveParam->m_lpchVLCPath) + 1];
		strcpy( m_lpchVLCPath, pToWaveParam->m_lpchVLCPath);

		m_lpchExt = new TCHAR[ MAX_PATH];
		strcpy( m_lpchExt, pToWaveParam->m_lpchExt);

		m_bCreateDelayWav = pToWaveParam->m_bCreateDelayWav;

		m_bDelayWavDirectOut = pToWaveParam->m_bDelayWavDirectOut;

		m_blgBilingMode = pToWaveParam->m_blgBilingMode;

		m_nBufferSizeMB = pToWaveParam->m_nBufferSizeMB;

		m_bOrgWavToTrashBox = pToWaveParam->m_bOrgWavToTrashBox;

		m_nReverseDelay = pToWaveParam->m_nReverseDelay;

		m_bUseLibFaad2 = pToWaveParam->m_bUseLibFaad2;

		m_bPrgrsWinTopMost = pToWaveParam->m_bPrgrsWinTopMost;

		m_bCreateLogFile = pToWaveParam->m_bCreateLogFile;

		// 
		m_bLoadFaad2Lib = pToWaveParam->m_bLoadFaad2Lib;
	}
	else
	{	// lȂ
		m_lpchVLCPath = new TCHAR[ MAX_PATH];
		*m_lpchVLCPath = 0x00;

		m_lpchExt = new TCHAR[ MAX_PATH];
		strcpy( m_lpchExt, eDEF_EXT);

		m_bCreateDelayWav = eDEF_CREATE_DELAY_WV;

		m_bDelayWavDirectOut = eDEF_DELAY_WAV_DIRECT_OUT;

		m_blgBilingMode = eDEF_BILING_MODE;

		m_nBufferSizeMB = eDEF_BUFFER_SIZE;

		m_bOrgWavToTrashBox = eDEF_ORG_WAV_TO_TRASHBOX;

		m_nReverseDelay = eDEF_REVERSE_DELAY;

		m_bUseLibFaad2 = eDEF_USE_LIBFAAD2;

		m_bPrgrsWinTopMost = eDEF_PRGRS_WIN_TOP_MOST;

		m_bCreateLogFile = eDEF_CREATE_LOG_FILE;

		// 
		m_bLoadFaad2Lib = FALSE;
	}

	// gqꗗ쐬
	m_lppchExtList = NULL;
	m_nExtNum = 0;

	CreateExtList();
}


// fXgN^
CToWaveParam::~CToWaveParam()
{
	INT		lc;

	delete m_lpchVLCPath;
	delete m_lpchExt;

	for( lc=0; lc<m_nExtNum; lc++)
	{
		delete *( m_lppchExtList + lc);
	}
	delete m_lppchExtList;
}


// init@Cǂݍ
VOID	CToWaveParam::ReadParam( VOID)
{
	// init@C𐶐
	TCHAR	szIniFileName[ MAX_PATH];
	GetModuleFileName( NULL, szIniFileName, MAX_PATH);					// sAṽtpX擾
	strcpy( PathFindExtension( szIniFileName), ".ini");					// gq ".exe" -> ".ini" ɕύX

	// VLC̃pX
	GetPrivateProfileString( eINI_SECTION_NAME, eINI_KEY_VLC_PATH, m_lpchVLCPath, m_lpchVLCPath, MAX_PATH, szIniFileName);

	// Ήgq
	GetPrivateProfileString( eINI_SECTION_NAME, eINI_KEY_EXT, m_lpchExt, m_lpchExt, MAX_PATH, szIniFileName);

	// libfaad2.dllgp
	m_bUseLibFaad2 = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_USE_LIBFAAD2, m_bUseLibFaad2, szIniFileName);

	// Delay𒲐WAV𐶐
	m_bCreateDelayWav = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_CREATE_DELAY_WAV, m_bCreateDelayWav, szIniFileName);

	// 񃖍Ed
	m_blgBilingMode = ( BILINGMODE)GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_BILING_MODE, m_blgBilingMode, szIniFileName);

	// obt@TCY
	m_nBufferSizeMB = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_BUFFER_SIZE, m_nBufferSizeMB, szIniFileName);

	// IWiWAVS~ɓ
	m_bOrgWavToTrashBox = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_DELETE_ORGWAV, m_bOrgWavToTrashBox, szIniFileName);

	// Delay̕𔽓]
	m_nReverseDelay = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_REVERSE_DELAY, m_nReverseDelay, szIniFileName);

	// oߕ\EChEőOʂɕ\
	m_bPrgrsWinTopMost = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_PRGRS_WIN_TOPMOST, m_bPrgrsWinTopMost, szIniFileName);

	// ڍׂȃOt@Co͂
	m_bCreateLogFile = GetPrivateProfileInt( eINI_SECTION_NAME, eINI_KEY_CREATE_LOGFILE, m_bCreateLogFile, szIniFileName);
}

// init@Cɏo
VOID	CToWaveParam::WriteParam( VOID)
{
	TCHAR	chText[ 4096];
	TCHAR	szIniFileName[ MAX_PATH];
	GetModuleFileName( NULL, szIniFileName, MAX_PATH);					// sAṽtpX擾
	strcpy( PathFindExtension( szIniFileName), ".ini");					// gq ".exe" -> ".ini" ɕύX

	// VLC̃pX
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_VLC_PATH, m_lpchVLCPath, szIniFileName);

	// Ήgq
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_EXT, m_lpchExt, szIniFileName);

	// libfaad2.dll gp
	sprintf( chText, "%d", m_bUseLibFaad2);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_USE_LIBFAAD2, chText, szIniFileName);

	// Delay𒲐WAV𐶐
	sprintf( chText, "%d", m_bCreateDelayWav);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_CREATE_DELAY_WAV, chText, szIniFileName);

	// 񃖍Ed
	sprintf( chText, "%d", m_blgBilingMode);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_BILING_MODE, chText, szIniFileName);

	// obt@TCY
	sprintf( chText, "%d", m_nBufferSizeMB);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_BUFFER_SIZE, chText, szIniFileName);

	// IWiWAVS~ɓ
	sprintf( chText, "%d", m_bOrgWavToTrashBox);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_DELETE_ORGWAV, chText, szIniFileName);

	// Delay̕𔽓]
	sprintf( chText, "%d", m_nReverseDelay);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_REVERSE_DELAY, chText, szIniFileName);

	// oߕ\EChEőOʂɕ\
	sprintf( chText, "%d", m_bPrgrsWinTopMost);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_PRGRS_WIN_TOPMOST, chText, szIniFileName);

	// ڍׂȃOt@Co͂
	sprintf( chText, "%d", m_bCreateLogFile);
	WritePrivateProfileString( eINI_SECTION_NAME, eINI_KEY_CREATE_LOGFILE, chText, szIniFileName);
}

// ΉgqXg̍\z
VOID	CToWaveParam::CreateExtList( VOID)
{
	INT		lc;
	INT		nIndex;

	for( lc=0; lc<m_nExtNum; lc++)
	{
		delete *( m_lppchExtList + lc);
	}
	delete m_lppchExtList;

	m_lppchExtList = NULL;
	m_nExtNum = 0;

	// JEg
	LPSTR	lpchExt = m_lpchExt;
	LPSTR	lpchExtStart = lpchExt;
	while( ( lpchExt = strchr( lpchExt, ';')))
	{	// 
		lpchExt++;
		lpchExtStart = lpchExt;
		m_nExtNum++;
	}
	if( strlen( lpchExtStart) >= 1) m_nExtNum++;

	// Xg\z
	if( m_nExtNum)
	{
		m_lppchExtList = new LPSTR[ m_nExtNum];
		nIndex = 0;

		lpchExtStart = lpchExt = m_lpchExt;
		while( ( lpchExt = strchr( lpchExt, ';')))
		{	// 
			*( m_lppchExtList + nIndex) = new TCHAR[ lpchExt - lpchExtStart + 1];
			memcpy( *( m_lppchExtList + nIndex), lpchExtStart, lpchExt - lpchExtStart);
			*( ( *( m_lppchExtList + nIndex)) + ( lpchExt - lpchExtStart)) = 0x00;
			nIndex++;

			lpchExt++;
			lpchExtStart = lpchExt;
		}
		if( strlen( lpchExtStart) >= 1)
		{
			*( m_lppchExtList + nIndex) = new TCHAR[ strlen( lpchExtStart) + 1];
			strcpy( *( m_lppchExtList + nIndex), lpchExtStart);
		}
	}
}

// f[^`FbN
VOID	CToWaveParam::DataCheck( VOID)
{
	if( m_nExtNum == 0)
	{
		strcpy( m_lpchExt, eDEF_EXT);
		CreateExtList();
	}

	m_bCreateDelayWav = m_bCreateDelayWav? TRUE: FALSE;
	m_bDelayWavDirectOut = m_bDelayWavDirectOut? TRUE: FALSE;
	if( m_blgBilingMode >= eBILINGMODE_NUM) m_blgBilingMode = eBILINGMODE_BOTH;
	if( m_blgBilingMode < 0) m_blgBilingMode = eBILINGMODE_BOTH;
	m_bOrgWavToTrashBox = m_bOrgWavToTrashBox? TRUE: FALSE;
	m_nReverseDelay = m_nReverseDelay? TRUE: FALSE;
	m_bUseLibFaad2 = m_bUseLibFaad2? TRUE: FALSE;
	if( eBUFFER_SIZE_MIN > m_nBufferSizeMB) m_nBufferSizeMB = eBUFFER_SIZE_MIN;
	if( m_nBufferSizeMB > eBUFFER_SIZE_MAX) m_nBufferSizeMB = eBUFFER_SIZE_MAX;
	m_bPrgrsWinTopMost = m_bPrgrsWinTopMost? TRUE: FALSE;
	m_bCreateLogFile = m_bCreateLogFile? TRUE: FALSE;
}
